//+------------------------------------------------------------------+
//| Pips Collector                                                   |
//| Copyright  2008 Eitan Zangi eitanmbox@gmail.com                 |
//| 25-10-2012                                                       |
//+------------------------------------------------------------------+ 

//+------------------------------------------------------------------+
//| Parameters                                                       |
//+------------------------------------------------------------------+
string   StrVer            = "Ver. 3.06 ";

#property copyright "Copyright Eitan Zangi"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Lime 
#property indicator_color3 White
#property indicator_color5 Yellow
#property indicator_color7 Aqua 

#property indicator_color2 DeepPink 
#property indicator_color4 White 
#property indicator_color6 Yellow 
#property indicator_color8 Aqua 
 
extern   bool  pAlertNewSignal = true;
extern   color pColorInfo      = White;
 
int      SaveBarTime = 0; 
int      Slope_Sell;  
int      Slope_Buy; 
int      I;
int      HighestBar;  
int      LowestBar;  
int      PriceRange;
int      ArrowDis; 
int      MinSlope;
int      MinSL;
 
double   Buffer_0[];
double   Buffer_1[];
double   Buffer_2[];
double   Buffer_3[]; 
double   Buffer_4[];
double   Buffer_5[];
double   Buffer_6[];
double   Buffer_7[];
 
double   MyPoint; 
double   SL_Dis;
double   SL; 
double   Spread;
double   Pips; 
 
double   BB_Up_3;
double   BB_Dn_3;
double   BB_Up_4;
double   BB_Dn_4;
 
double   SMA32_9;
double   SMA20_0;
double   SMA32_0;
double   TMA_Up_10; 
double   TMA_Dn_10; 
double   Check;

double   TSUp_1;
double   TSDn_1; 
double   TSUp_2;
double   TSDn_2;
double   TSUp_3;
double   TSDn_3;
double   TS_1; 
double   BlueMA;
double   RedMA;
double   Min_MA_Dis;
 
bool     BlockInd;
 
string   Line01ObjName  = "Line01ObjName"; 
string   Line02ObjName  = "Line02ObjName";
string   Line03ObjName  = "Line03ObjName";
string   Line04ObjName  = "Line04ObjName";  
string   Line05ObjName  = "Line05ObjName"; 
string   Line06ObjName  = "Line06ObjName"; 
string   Line07ObjName  = "Line07ObjName"; 
string   Line08ObjName  = "Line08ObjName"; 
string   Line09ObjName  = "Line09ObjName"; 
string   Line98ObjName  = "Line98ObjName"; 
string   Line99ObjName  = "Line99ObjName"; 
 
string   MsgBuffer1; 
string   MsgBuffer2; 
string   StrBuffer;
string   StrSpread; 
string   StrType;
string   StrPips; 
string   StrProfit; 
string   StrBuffer1;
string   StrBuffer2;
string   StrBuffer3;
string   StrBuffer4;
string   StrSL;
string   StrTP;
string   StrSMA20_1;
string   StrSMA32_1; 
string   StrTF;
 
string   ConLocal        = "Local Time    " ;
string   ConBroker       = "Broker Time  " ; 
string   ConSpread       = "Spread            " ; 
//+------------------------------------------------------------------+
//| Indicator initialization function                                |
//+------------------------------------------------------------------+
void init()
{
   IndicatorBuffers(8);
   SetIndexStyle(0, DRAW_ARROW, 0, 3, Lime);
   SetIndexArrow(0, 233);
   SetIndexStyle(1, DRAW_ARROW, 0, 3, DeepPink);
   SetIndexArrow(1, 234);
   SetIndexStyle(2, DRAW_ARROW, 0, 3, White);
   SetIndexArrow(2, 159);
   SetIndexStyle(3, DRAW_ARROW, 0, 3, White);
   SetIndexArrow(3, 159);
   SetIndexStyle(4, DRAW_ARROW, 0, 1, Yellow);
   SetIndexArrow(4, 140); 
   SetIndexStyle(5, DRAW_ARROW, 0, 1, Yellow);
   SetIndexArrow(5, 140);
   SetIndexStyle(6, DRAW_ARROW, 0, 1, Aqua);
   SetIndexArrow(6, 141);
   SetIndexStyle(7, DRAW_ARROW, 0, 1, Aqua);
   SetIndexArrow(7, 141); 
   
   SetIndexBuffer(0, Buffer_0);
   SetIndexBuffer(1, Buffer_1);  
   SetIndexBuffer(2, Buffer_2);
   SetIndexBuffer(3, Buffer_3);  
   SetIndexBuffer(4, Buffer_4);
   SetIndexBuffer(5, Buffer_5);
   SetIndexBuffer(6, Buffer_6);
   SetIndexBuffer(7, Buffer_7); 
 
   MyPoint = MarketInfo(Symbol() ,MODE_POINT); 
 
   if    (MarketInfo(Symbol(), MODE_DIGITS) == 5 || MarketInfo(Symbol(), MODE_DIGITS) == 3)    
          MyPoint = MyPoint * 10; 
 
   if    (Period() == PERIOD_M1)  StrTF = " [M1]";   
   if    (Period() == PERIOD_M5)  StrTF = " [M5]";   
   if    (Period() == PERIOD_M15) StrTF = " [M15]"; 
   if    (Period() == PERIOD_M30) StrTF = " [M30]";  
   if    (Period() == PERIOD_H1)  StrTF = " [H1]";  
   if    (Period() == PERIOD_H4)  StrTF = " [H4]";   
   if    (Period() == PERIOD_D1)  StrTF = " [D1]";    
   if    (Period() == PERIOD_W1)  StrTF = " [W1]";   
   if    (Period() == PERIOD_MN1) StrTF = " [MN]";        
             
  	ObjectCreate (Line01ObjName, OBJ_LABEL, 0, 0, 0);
	ObjectSetText(Line01ObjName, "http://PipsCollector.com", 12, "David Transparent", pColorInfo);
	ObjectSet    (Line01ObjName, OBJPROP_YDISTANCE, 3); 	
	ObjectSet    (Line01ObjName, OBJPROP_XDISTANCE, 5);	
	ObjectSet    (Line01ObjName, OBJPROP_CORNER, 3);            
} 
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   ObjectDelete(Line01ObjName); 
   ObjectDelete(Line02ObjName);   
   ObjectDelete(Line03ObjName); 
   ObjectDelete(Line04ObjName); 
   ObjectDelete(Line05ObjName); 
   ObjectDelete(Line06ObjName);   
   ObjectDelete(Line07ObjName); 
   ObjectDelete(Line08ObjName); 
   ObjectDelete(Line09ObjName); 
   ObjectDelete(Line98ObjName); 
   ObjectDelete(Line99ObjName);
}
//+------------------------------------------------------------------+
//|  Indicator start function                                         |
//+------------------------------------------------------------------+
void start()
{ 
   TMA_Up_10 = iCustom(NULL, 0, "PC_T", 1, 10);    
   TMA_Dn_10 = iCustom(NULL, 0, "PC_T", 2, 10);  

   MsgBuffer1 = " ";
   MsgBuffer2 = " ";   
   Msg();	
   
   CheckIndExist();
   if    (BlockInd) return;   
 
   PriceRange = (TMA_Up_10 - TMA_Dn_10) / MyPoint;
   MinSlope   = PriceRange * 0.11;     
   MinSL      = PriceRange * 0.44;
   ArrowDis   = PriceRange * 0.09;
   Min_MA_Dis = PriceRange * 0.025; 
 
   AccountInfo();
   OrderManagenent();

   int Limit;
   int counted_bars = IndicatorCounted();
 
   if    (counted_bars<0) return(-1);
 
   if    (counted_bars>0) counted_bars--;
   Limit = Bars - counted_bars;
     
   for   (int I = Limit; I >= 0; I--)
         { 
         Get_SMA_Values_1(I); 
         Get_SMA_Values_2(I);          
         Get_TS_Values (I); 
         Get_BB_Values(I);          
   
         Buffer_0[I] = 0.0;
         Buffer_1[I] = 0.0; 
         Buffer_2[I] = 0.0;
         Buffer_3[I] = 0.0; 
         Buffer_4[I] = 0.0;
         Buffer_5[I] = 0.0; 
         Buffer_6[I] = 0.0;
         Buffer_7[I] = 0.0;  
         
         BlueMA = iCustom(NULL, Period(), "PC_100", 3, I+1); 
         RedMA  = iCustom(NULL, Period(), "PC_100", 2, I+1); 
 
//+-------------------- Long Terms ----------------------------------+  
  
         if   (TSUp_2 > 0 && TSDn_2 > 0 &&  TSUp_3 == 0 &&  TSDn_3 > 0 && TS_1 > SMA32_0)
               if    (StrSMA20_1 == "Buy" && StrSMA32_1 == "Buy")
                      if   (Slope_Buy >= MinSlope && SMA20_0 > SMA32_0)
                            if   ((BlueMA - RedMA) / MyPoint > Min_MA_Dis)  
                                 {           
                                 Buffer_0[I+1] = Low[I+1]  - (ArrowDis * MyPoint); 
                                 Get_SL(I+1, OP_BUY);                            
                                 Buffer_2[I+1] = SL;
                                 Buffer_4[I+1] = BB_Up_3;
                                 Buffer_6[I+1] = BB_Up_4;
                                 }       
                                                        
//+-------------------- Short Terms ---------------------------------+  
                            
         if   (TSUp_2 > 0 && TSDn_2 > 0 && TSUp_3 > 0  && TSDn_3 == 0  && TS_1 < SMA32_0)  
               if   (StrSMA20_1 == "Sell" && StrSMA32_1 == "Sell")
                     if   (Slope_Sell >= MinSlope && SMA20_0 < SMA32_0)
                           if   ((RedMA - BlueMA) / MyPoint > Min_MA_Dis)  
                                {              
                                Buffer_1[I+1] = High[I+1] + (ArrowDis * MyPoint);
                                Get_SL(I+1, OP_SELL);                           
                                Buffer_3[I+1] = SL;
                                Buffer_5[I+1] = BB_Dn_3; 
                                Buffer_7[I+1] = BB_Dn_4;  
                                }
   }  
                                  
   AlertSound();                                
} 
//+------------------------------------------------------------------+
//|  Alert Sound                                                     |
//+------------------------------------------------------------------+
void AlertSound()
{ 
   if    (iTime(NULL, Period(), 0) == SaveBarTime)
          return;          
 
   SaveBarTime = iTime(NULL, Period(), 0);
   
   if   (! pAlertNewSignal) return;
   
   if    (Buffer_0[I+1] > 0)                                 
          Alert("Pips Collector Buy Signal [",  Symbol(), "]", StrTF);    
          
   if    (Buffer_1[I+1] > 0)  
          Alert("Pips Collector Sell Signal [",  Symbol(), "]", StrTF);  
} 
//+------------------------------------------------------------------+
//|  Get TS Values                                                   |
//+------------------------------------------------------------------+
void Get_TS_Values(int Bar)
{ 
   TSUp_1 = iCustom(NULL, 0, "PC_TS", 0, Bar+1); 
   TSDn_1 = iCustom(NULL, 0, "PC_TS", 1, Bar+1);   
         
   TSUp_2 = iCustom(NULL, 0, "PC_TS", 0, Bar+2); 
   TSDn_2 = iCustom(NULL, 0, "PC_TS", 1, Bar+2);  
   
   TSUp_3 = iCustom(NULL, 0, "PC_TS", 0, Bar+3); 
   TSDn_3 = iCustom(NULL, 0, "PC_TS", 1, Bar+3);     
   
   if    (TSUp_1 > 10000) TSUp_1 = 0;     
   if    (TSDn_1 > 10000) TSDn_1 = 0;    
   if    (TSUp_2 > 10000) TSUp_2 = 0;     
   if    (TSDn_2 > 10000) TSDn_2 = 0; 
   if    (TSUp_3 > 10000) TSUp_3 = 0;     
   if    (TSDn_3 > 10000) TSDn_3 = 0;  
   
   if    (TSUp_1 > 0) TS_1 = TSUp_1;    
   if    (TSDn_1 > 0) TS_1 = TSDn_1;               
}
//+------------------------------------------------------------------+
//|  Get_SMA_Values                                                  |
//+------------------------------------------------------------------+
void Get_SMA_Values_1(int Bar)
{ 
    if  (iCustom(NULL, Period(), "PC_20", 1, Bar) < 1000000) 
        StrSMA20_1 = "Buy";
        
    if  (iCustom(NULL, Period(), "PC_20", 2, Bar) < 1000000) 
        StrSMA20_1 = "Sell";
        
    if  (iCustom(NULL, Period(), "PC_32", 1, Bar) < 1000000) 
        StrSMA32_1 = "Buy";
        
    if  (iCustom(NULL, Period(), "PC_32", 2, Bar) < 1000000) 
        StrSMA32_1 = "Sell"; 
}
//+------------------------------------------------------------------+
//|  Get_SMA_Values                                                  |
//+------------------------------------------------------------------+
void Get_SMA_Values_2(int Bar)
{ 
   SMA20_0 = iMA(NULL, Period(), 20, 0, MODE_SMA, PRICE_CLOSE, Bar); 
   SMA32_0 = iMA(NULL, Period(), 32, 0, MODE_SMA, PRICE_CLOSE, Bar);    
 
   SMA32_9 = iMA(NULL, Period(), 32, 0, MODE_SMA, PRICE_CLOSE, Bar+9);   
    
   Slope_Buy  = (SMA32_0 - SMA32_9) / MyPoint; 
   Slope_Sell = (SMA32_9 - SMA32_0) / MyPoint;          
}
//+------------------------------------------------------------------+
//|  Get BB Values                                                   |
//+------------------------------------------------------------------+
void Get_BB_Values(int Bar)
{
   BB_Up_3 =  iBands(NULL, 0, 34, 3, 0, PRICE_CLOSE, MODE_UPPER, Bar);
   BB_Dn_3 =  iBands(NULL, 0, 34, 3, 0, PRICE_CLOSE, MODE_LOWER, Bar);     
   
   BB_Up_4 =  iBands(NULL, 0, 34, 4, 0, PRICE_CLOSE, MODE_UPPER, Bar);
   BB_Dn_4 =  iBands(NULL, 0, 34, 4, 0, PRICE_CLOSE, MODE_LOWER, Bar);        
}  
//+------------------------------------------------------------------+
//|  Get_SL                                                   |
//+------------------------------------------------------------------+
void Get_SL(int Bar, int Type)
{ 
   if    (Type == OP_BUY)
         { 
         LowestBar = iLowest(NULL, 0, MODE_LOW, 10, Bar);         
         SL = Low[LowestBar] - (5 * MyPoint); 
         
         SL_Dis = (iClose(NULL, 0, Bar) - SL) / MyPoint;
         if    (SL_Dis < MinSL)
                SL  = iClose(NULL, 0, Bar) - (MinSL *  MyPoint); 
         } 
  
               
   if    (Type == OP_SELL)
         { 
         HighestBar = iHighest(NULL, 0, MODE_HIGH, 10, Bar);         
         SL = High[HighestBar] + (5 * MyPoint); 
         
         SL_Dis = (SL - iClose(NULL, 0, Bar)) / MyPoint;
         if    (SL_Dis < MinSL)
                SL  = iClose(NULL, 0, Bar) + (MinSL *  MyPoint); 
         }        
}
//+------------------------------------------------------------------+
//|   Check Ind Exist                                                |
//+------------------------------------------------------------------+
void  CheckIndExist()
{  
   BlockInd = 0; 
   
   Check = iCustom(NULL, 0, "PC_T", 1, 10); 
   if    (Check == 0)
         {
         MsgBuffer1 = "Custom Indicators - File not found:"; 
         MsgBuffer2 = "PC_T, PC_TS, PC_20, PC_32, PC_100";         
         Msg();
         BlockInd = true;
         return;
         }    
         
   Check = iCustom(NULL, 0, "PC_TS", 0, 1); 
   if    (Check == 0)
         {
         MsgBuffer1 = "Custom Indicators - File not found:"; 
         MsgBuffer2 = "PC_T, PC_TS, PC_20, PC_32, PC_100"; 
         Msg();
         BlockInd = true;
         return;
         }    
         
   Check = iCustom(NULL, Period(), "PC_20", 1, 1);
   if    (Check == 0)
         {
         MsgBuffer1 = "Custom Indicators - File not found:"; 
         MsgBuffer2 = "PC_T, PC_TS, PC_20, PC_32, PC_100"; 
         Msg();
         BlockInd = true;
         return;
         }   
         
   Check = iCustom(NULL, Period(), "PC_32", 1, 1);
   if    (Check == 0)
         {
         MsgBuffer1 = "Custom Indicators - File not found:"; 
         MsgBuffer2 = "PC_T, PC_TS, PC_20, PC_32, PC_100"; 
         Msg();
         BlockInd = true;
         return;
         }   
         
   Check = iCustom(NULL, Period(), "PC_100", 3, 1);
   if    (Check == 0)
         {
         MsgBuffer1 = "Custom Indicators - File not found:"; 
         MsgBuffer2 = "PC_T, PC_TS, PC_20, PC_32, PC_100"; 
         Msg();
         BlockInd = true;
         return;
         }                                               
}
//+------------------------------------------------------------------+
//| Msg                                                              |
//+------------------------------------------------------------------+
void Msg()
{ 
	ObjectCreate (Line98ObjName, OBJ_LABEL, 0, 0, 0);
	ObjectSetText(Line98ObjName, MsgBuffer1, 14, "David Transparent", White);
	ObjectSet    (Line98ObjName, OBJPROP_YDISTANCE, 43);	
	ObjectSet    (Line98ObjName, OBJPROP_XDISTANCE, 190);   
	
	ObjectCreate (Line99ObjName, OBJ_LABEL, 0, 0, 0);
	ObjectSetText(Line99ObjName, MsgBuffer2, 14, "David Transparent", White);
	ObjectSet    (Line99ObjName, OBJPROP_YDISTANCE, 63);	
	ObjectSet    (Line99ObjName, OBJPROP_XDISTANCE, 190); 	
}         
//+------------------------------------------------------------------+
//|   Account Info                                                   |
//+------------------------------------------------------------------+
void  AccountInfo()
{ 
 	StrBuffer = ConLocal + TimeToStr(TimeLocal(), TIME_MINUTES); 	 
	ObjectCreate (Line03ObjName, OBJ_LABEL, 0, 0, 0);
	ObjectSetText(Line03ObjName, StrBuffer, 12, "David Transparent", pColorInfo);
	ObjectSet    (Line03ObjName, OBJPROP_YDISTANCE, 3); 	
	ObjectSet    (Line03ObjName, OBJPROP_XDISTANCE, 3);
	
	StrBuffer = ConBroker + TimeToStr(TimeCurrent(), TIME_MINUTES); 
	ObjectCreate (Line04ObjName, OBJ_LABEL, 0, 0, 0);
	ObjectSetText(Line04ObjName, StrBuffer, 12, "David Transparent", pColorInfo);
	ObjectSet    (Line04ObjName, OBJPROP_YDISTANCE, 23); 	
	ObjectSet    (Line04ObjName, OBJPROP_XDISTANCE, 3);
	
   Spread = MarketInfo(Symbol(), MODE_SPREAD);
   if    (MarketInfo(Symbol(), MODE_DIGITS) == 5 || MarketInfo(Symbol(), MODE_DIGITS) == 3)
         {
         Spread = Spread / 10;
         StrSpread = DoubleToStr(Spread, 1);
         }
   else 
         StrSpread = DoubleToStr(Spread, 0); 
         
	StrBuffer = ConSpread + StrSpread; 
	ObjectCreate (Line05ObjName, OBJ_LABEL, 0, 0, 0);
	ObjectSetText(Line05ObjName, StrBuffer, 12, "David Transparent", pColorInfo);
	ObjectSet    (Line05ObjName, OBJPROP_YDISTANCE, 43); 	
	ObjectSet    (Line05ObjName, OBJPROP_XDISTANCE, 3);  
	
//------------------------------------------------------------------
  
	ObjectCreate (Line06ObjName, OBJ_LABEL, 0, 0, 0);
	ObjectSetText(Line06ObjName, StrBuffer1, 12, "David Transparent", pColorInfo);
	ObjectSet    (Line06ObjName, OBJPROP_YDISTANCE, 83); 	
	ObjectSet    (Line06ObjName, OBJPROP_XDISTANCE, 3);
 
 	ObjectCreate (Line07ObjName, OBJ_LABEL, 0, 0, 0);
	ObjectSetText(Line07ObjName, StrBuffer2, 12, "David Transparent", pColorInfo);
	ObjectSet    (Line07ObjName, OBJPROP_YDISTANCE, 103); 	
	ObjectSet    (Line07ObjName, OBJPROP_XDISTANCE, 3); 
 
 	ObjectCreate (Line08ObjName, OBJ_LABEL, 0, 0, 0);
	ObjectSetText(Line08ObjName, StrBuffer3, 12, "David Transparent", pColorInfo);
	ObjectSet    (Line08ObjName, OBJPROP_YDISTANCE, 123); 	
	ObjectSet    (Line08ObjName, OBJPROP_XDISTANCE, 3); 
 
	ObjectCreate (Line09ObjName, OBJ_LABEL, 0, 0, 0);
	ObjectSetText(Line09ObjName, StrBuffer4, 12, "David Transparent", pColorInfo);
	ObjectSet    (Line09ObjName, OBJPROP_YDISTANCE, 143); 	
	ObjectSet    (Line09ObjName, OBJPROP_XDISTANCE, 3); 
} 
//+------------------------------------------------------------------+
//|  Order Managenent                                                |
//+------------------------------------------------------------------+
void OrderManagenent()
{ 
   StrBuffer1 = "";
   StrBuffer2 = "";
   StrBuffer3 = "";
   StrBuffer4 = ""; 
 
   for   (int i = 0; i < OrdersTotal(); i++) 
         {
         OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if    (OrderSymbol() == Symbol() && OrderType() < 2)                // Only OP_BUY & OP_SELL 
                OrderInfo(); 
         } 
} 
//+------------------------------------------------------------------+
//|   Order Info                                                     |
//+------------------------------------------------------------------+
void  OrderInfo()
{    
   if    (OrderType() == OP_BUY)  
         { 
         Pips = (Bid - OrderOpenPrice()) / MyPoint;         
         StrType = "Buy";
         }
    
   if    (OrderType() == OP_SELL)  
         {
         Pips = (OrderOpenPrice() - Ask) / MyPoint;   
         StrType = "Sell";
         }
         
   if    (MarketInfo(Symbol(), MODE_DIGITS) == 5 || MarketInfo(Symbol(), MODE_DIGITS) == 3)
         { 
         StrPips = DoubleToStr(Pips, 1);
         }
   else 
         StrPips = DoubleToStr(Pips, 0); 
                  
         
  	StrBuffer1 = "Order Type    " + StrType; 	 
 
   StrSL = DoubleToStr(OrderStopLoss(), MarketInfo(Symbol(), MODE_DIGITS));  
   StrBuffer2 = "Stop Loss       " + StrSL; 
 
   StrTP = DoubleToStr(OrderTakeProfit(), MarketInfo(Symbol(), MODE_DIGITS));  
   StrBuffer3 = "Take Profit     " + StrTP; 
 
 	StrBuffer4 = "Profit              " + StrPips + " Pips"; 	   
} 
//+------------------------------------------------------------------+
//| End                                                              |
//+------------------------------------------------------------------+ 